; Loyd v1.1 made by Alban Gervaise
; for Doorsos v0.91Beta
; Last up_dated 12/12/98

        include "doorsos.h"
        include "graphlib.h"
        include "userlib.h"
        include "all.map"   ; file where are stored the pictures

        xdef _main
        xdef _comment
        xdef _ti89


difficulty = 4  ; change the difficulty (1-15 [15=easy])

Print_d0 MACRO
        bsr print_value
        move.w  \3,-(a7)
        move.l  a0,-(a7)
        move.w  \2,-(a7)
        move.w  \1,-(a7)
        jsr     doorsos::DrawStrXY
        lea 10(a7),a7
        ENDM


_main:  move.l #sprite,sprite_addr
        clr.b picnbr
print_menu:
        move.b #16,pos
        bsr setup_level
        bsr gray_off
        bsr print_nombre
        move.w #2,-(a7)
        jsr doorsos::FontSetSys
        clr.w -(a7)           
        jsr doorsos::ST_busy
        move.w #1,-(a7)
        pea title(pc)
        move.w #20,-(a7)
        move.w #85,-(a7)
        jsr doorsos::DrawStrXY
        pea choose(pc)
        jsr doorsos::ST_showHelp
        clr.w -(a7)
        jsr doorsos::FontSetSys
        move.w #1,-(a7)
        pea author(pc)
        move.w #35,-(a7)
        move.w #100,-(a7)
        jsr doorsos::DrawStrXY
        lea 30(a7),a7

choose_loop:
        jsr userlib::idle_loop
        cmp.w #264,d0
        beq gray_off
        cmp.w #277,d0
        beq gray_off
        cmp.w #13,d0
        beq start_game
        cmp.w #338,d0
        beq avant
        cmp.w #344,d0
        bne choose_loop
        cmp.b #pic_nbr-1,picnbr
        beq choose_loop
        add.b #1,picnbr
        add.l #540,sprite_addr
        bra print_menu

avant   tst.b picnbr
        beq choose_loop
        sub.b #1,picnbr
        sub.l #540,sprite_addr
        bra print_menu

start_game:
        bsr gray_off
        clr.w -(a7)           ; met la petite fonte
        jsr doorsos::FontSetSys      ;
        lea 2(a7),a7
        jsr graphlib::clr_scr
        bsr setup_level
        clr.w moves
        move.b #16,pos
        bsr print_nombre
        bsr ini_random
        bsr gray_off
        clr.w timer
        clr.w time
        bsr info
        bsr print_nombre
        jsr userlib::idle_loop
key_loop:
        add.w #1,timer
        cmp.w #40000,timer
        bne \passe
        add.w #1,time
        clr.w timer
        bsr info
\passe  bsr get_key
        cmp.w #264,d0
        beq print_menu
        cmp.w #277,d0           ; si HOME, on quitte
        beq gray_off
        cmp.w #338,d0
        beq rechts
        cmp.w #344,d0
        beq link
        cmp.w #337,d0
        beq oben
        cmp.w #340,d0
        beq hoch
        cmp.w #266,d0
        beq show_pic
        cmp.w #263,d0
        beq start_game
        cmp.w #267,d0
        beq off
        bra key_loop

link    bsr gauche
        tst.b d0
        beq key_loop
        bra check

rechts  bsr droite
        cmp.b #1,d0
        beq key_loop
        bra check

hoch    bsr haut
        cmp.b #3,d0
        beq key_loop
        bra check

oben    bsr bas
        tst.b d0
        beq key_loop
        bra check

gauche  clr.l d0
        move.b pos,d0
        divu #4,d0
        swap d0
        tst.b d0
        beq exit
        clr.l d0
        move.b pos,d0
        move.l #level,a0
        add.l d0,a0
        move.b (a0),d0
        clr.b (a0)
        move.b d0,-(a0)
        add.b #1,pos
        bsr print_nombre
        rts
droite  clr.l d0
        move.b pos,d0
        divu #4,d0
        swap d0
        cmp.b #1,d0
        beq exit
        clr.l d0
        move.b pos,d0
        sub.b #2,d0
        move.l #level,a0
        add.l d0,a0
        move.b (a0),d0
        clr.b (a0)
        add.l #1,a0
        move.b d0,(a0)
        sub.b #1,pos
        bsr print_nombre
        rts
bas     clr.l d0
        move.b pos,d0
        sub.b #1,d0
        divu #4,d0
        tst.b d0
        beq exit
        clr.l d0
        move.b pos,d0
        sub.b #5,d0
        move.l #level,a0
        add.l d0,a0
        move.b (a0),d0
        clr.b (a0)
        add.l #4,a0
        move.b d0,(a0)
        sub.b #4,pos
        bsr print_nombre
        rts
haut    clr.l d0
        move.b pos,d0
        sub.b #1,d0
        divu #4,d0
        cmp.b #3,d0
        beq exit
        clr.l d0
        move.b pos,d0
        add.b #3,d0
        move.l #level,a0
        add.l d0,a0
        move.b (a0),d0
        clr.b (a0)
        sub.l #4,a0
        move.b d0,(a0)
        add.b #4,pos
        bsr print_nombre
        rts
off     trap #4
        bra key_loop

gray_off:
        movem d0,-(a7)
        move.l graphlib::plane1,a1
        jsr graphlib::clr_scr
        clr.w graphlib::choosescreen
        jsr graphlib::gray2
        movem (a7)+,d0
        rts

; CHECK THE GAME 

check   add.w #1,moves
        bsr info
        move.l #level,a0
        clr.b d0
        move.b #14,d1
ck_lp   add.b #1,d0
        move.b (a0)+,d2
        cmp.b d2,d0
        bne key_loop
        dbra d1,ck_lp
        move.w #2,-(a7)
        jsr doorsos::FontSetSys
        move.w #4,-(a7)        
        pea win_str(pc)
        move.w #3,-(a7)        
        move.w #20,-(a7)        
        jsr doorsos::DrawStrXY
        move.l #press_ex,-(a7)
        jsr doorsos::ST_showHelp
        lea 16(a7),a7
\loop   bsr get_key
        cmp.w #264,d0
        beq print_menu
        cmp.w #13,d0
        bne \loop
        bra print_menu

; DISP THE LEVEL 

print_nombre:
        bsr gray_off
        jsr graphlib::clr_scr
        move.w #15,d0
        move.w #15,d1
        move.w #65,d4
        move.w #65,d5
        jsr graphlib::frame
        move.l #level,a2
        move.b #1,d5
        move.w #15,d6
print_nombre_loop:
        clr.l d2
        move.b (a2)+,d2
        tst.b d2
        beq \passe
        clr.l d0
        move.l sprite_addr,a0
        sub.b #1,d2
        mulu #36,d2
        add.l d2,a0
        move.b d5,d0
        bsr convert_type1
        move.w #%11111111,d3
        jsr graphlib::put_sprite_mask
\passe  add.b #1,d5
        dbra d6,print_nombre_loop
        move.l #press,-(a7)
        jsr doorsos::ST_showHelp
        clr.w -(a7)           ;
        jsr doorsos::ST_busy      ;   
        lea 6(a7),a7
        bsr print_gray
        rts

; CONVERT POSITION IN COORD 

convert_type1:        ;
        clr.l d1      ;
        sub.b #1,d0   ;
        divu #4,d0    ;
        move.b d0,d1  ; converti le numero de la case (1-16)
        mulu #16,d1   ; en coord x pour d0
        add.w #16,d1  ;          y pour d1
        clr.w d0      ;
        swap d0       ;
        mulu #16,d0   ;
        add.w #16,d0  ;
        rts           ;

; SHOW COMPLETED LEVEL 

show_pic:
        move.b pos,d0
        move.b d0,pos_pic
        move.b #16,pos
        move.l #level,a0
        move.l #pic,a1
        move.w #15,d0
copy_loop:
        move.b (a0)+,(a1)+
        dbra d0,copy_loop
        bsr setup_level
        bsr gray_off
        jsr graphlib::clr_scr
        bsr print_nombre
        jsr userlib::idle_loop
        move.l #level,a0
        move.l #pic,a1
        move.w #15,d0
copy_loop2:
        move.b (a1)+,(a0)+
        dbra d0,copy_loop2
        move.b pos_pic,d0
        move.b d0,pos
        bsr print_nombre
        move.w #1,d0                
        bra key_loop

; SETUP THE LEVEL 

setup_level:
        move.l #level,a0
        clr.b d1
        move.w #14,d0
\random add.b #1,d1
        move.b d1,(a0)+
        dbra d0,\random
        clr.b (a0)
        bsr print_nombre
        rts

; RANDOM MOVES 

ini_random:
        move.w #4,-(a7)
        pea change(pc)
        move.w #85,-(a7)
        move.w #20,-(a7)
        jsr doorsos::DrawStrXY
        lea 10(a7),a7
ini_lp  bsr gray_off
        move.w #4,d0
        jsr userlib::random
        tst.w d0
        beq left
        cmp.w #1,d0
        beq right
        cmp.w #2,d0
        beq up
        bsr bas
retour  move.l #level,a0
        clr.b d6
        clr.b d5
        move.w #15,d7
lpinir  add.b #1,d6
        cmp.b (a0)+,d6
        bne \non
        add.b #1,d5
\non    dbra d7,lpinir
        cmp.b #difficulty,d5
        bgt ini_lp
        bsr gray_off
        jsr graphlib::clr_scr
        bsr print_nombre
        rts
right   bsr droite
        bra retour
left    bsr gauche
        bra retour
up      bsr haut
        bra retour



; GIVES INFO 

info    pea email(pc)             ; affiche mon email et eteint
        jsr doorsos::ST_showHelp  ; l'indicateur de marche
        move.w moves,d0
        Print_d0 #130,#20,#4
        move.w #4,-(a7)        
        move.l #move_str,-(a7)
        move.w #20,-(a7)        
        move.w #100,-(a7)        
        jsr doorsos::DrawStrXY ; on affiche level_str avec le numro du level
        move.w time,d0
        Print_d0 #130,#30,#4
        move.w #4,-(a7)
        move.l #time_str,-(a7)
        move.w #30,-(a7)
        move.w #100,-(a7)
        jsr doorsos::DrawStrXY
        lea 24(a7),a7       ; on restore la stack
exit    rts


; PRINT A GRAY CURSOR 

print_gray:
        jsr graphlib::gray4
        move.w #1,graphlib::choosescreen
        move.l graphlib::plane1,a0
        clr.l d0
        clr.l d1      
        move.b pos,d0
        sub.b #1,d0  
        divu #4,d0    
        move.w d0,d1
        mulu #30*16,d1   
        add.w #30*16,d1
        clr.w d0      
        swap d0       
        mulu #2,d0   
        add.l #2,d0
        add.l d1,d0
        lea 0(a0,d0.l),a0
        move.l a0,a1
        move.w #16,d1
\loop   move.w #1,d0
        move.l a0,a1
\loop1  move.b #$FF,(a1)+
        dbra d0,\loop1
        add.l #30,a0
        dbra d1,\loop
        rts


print_value:
        move.l #str+8,a0
        clr.b (a0)
print_loop:
        divu #10,d0
        swap d0
        add.b #48,d0
        move.b d0,-(a0)
        clr.w d0
        swap d0
        tst.w d0
        bne print_loop
        rts

get_key tst.w (doorsos::kb_vars+$1C)
        beq exit
        move.w (doorsos::MaxHandles+$1E),d0
        clr.w (doorsos::kb_vars+$1C)
        rts


; SETUP VARS 


win_str   dc.b "CONGRATULATIONS!",0
move_str  dc.b "moves:",0
time_str  dc.b "time:",0

email dc.b "Loyd v1.1 Endive GefunS@I-France.com",0

press dc.b "press a key",0
press_ex dc.b "press [ENTER] or [ESC]",0
change dc.b "change order...",0

title dc.b "Loyd v1.1",0
author dc.b "by Endive!",0
choose dc.b "Choose your level ",17,32,18,0


_comment dc.b "Loyd v1.1 by Endive!",0

        BSS

time    ds.w 1
timer   ds.w 1
moves   ds.w 1
pic     ds.b 16
picnbr  ds.b 1
level   ds.b 16
pos_pic ds.b 1
pos     ds.b 1
sprite_addr dc.l 1
str     ds.b 9

 end

;made by Alban Gervaise
